<template>
  <div>
    <ModalDefault
      :title="$t('change_network.game')"
      :btnTitle="$t('change_network.accept')"
      ref="modal"
      :loading="loading"
      @close="$emit('close')"
      @submit="submitGameMode">
      <div class="modal_default-inner modal_default-inner-padding flex flex-center">
        <BSwitch
          @change="changeGameType"
          :checked="componentChecked"
          background="#f2a314"
          :activeText="$t('header.demo')"
          :inactiveText="$t('header.live')"></BSwitch>
      </div>
    </ModalDefault>

    <ModalDefault
      :title="$t('change_network.wallet')"
      ref="changeAccounts"
      :loading="loading"
      @close="$emit('close')"
      @submit="submitNewAccount">
      <div class="modal_default-inner">
        <div
          v-for="(item, key) in accountList"
          :key="key"
          class="modal_default-list flex flex-between flex-middle"
          :class="{'modal_default-list-checked': item===currentAccount}">
          <div
            class="flex flex-middle modal_default-list-checkbox"
            @click="chooseAccount(item)">
            <Checkbox :value="item===currentAccount"></Checkbox>
            <div class="modal_default-list-name">{{item.account_name ? item.account_name+'@'+item.permission_name : item}}</div>
          </div>
          <div
            class="modal_default-list-amount"
            v-if="priceMap[item]!==undefined">
            {{priceMap[item]}} EOS
          </div>
          <div v-else>{{$t('common.loading')}}</div>
        </div>
      </div>
    </ModalDefault>
  </div>
</template>

<script>
  import ModalDefault from '~/components/UI/Modal/Default';
  import Checkbox from '~/components/UI/Checkbox';
  import BSwitch from '~/components/UI/Switch';

  export default {
    name: "TheChangeNetwork",
    props: {
      checked: Boolean,
    },
    data() {
      return {
        accountList: [],
        priceMap: {},
        currentAccount: '',
        showDeposit: false,
        componentChecked: false,
        loading: false
      }
    },
    components: {
      BSwitch,
      ModalDefault,
      Checkbox
    },
    computed: {
      balance() {
        return this.$store.state.wallet.balance;
      },
      pubKey() {
        return this.$store.state.wallet.publicKey;
      },
      isDemo: {
        get() {
          return !this.$store.state.common.demo;
        },
        set(type) {
          this.loading = true;
          this.$store.dispatch('common/changeGameType', type).then(res => {
            if (type && res.currentAccount === 'No account') {
              this.createAccount();
              this.$root.$refs['loader'].show();
            } else {
              if (res.accountsList && res.accountsList.length > 1) {
                this.selectAccounts(res);
              }
            }
            this.continueSubmitingGameMode();
          });
        }
      },
      accountName() {
        return this.$store.state.wallet.accountName;
      }
    },
    methods: {
      submitNewAccount() {
        this.$store.dispatch('common/setAccount', this.currentAccount);
        this.$refs['changeAccounts'].show(false);
      },
      chooseAccount(account) {
        if (this.currentAccount === account) return;
        this.currentAccount = account;
      },
      selectAccounts(accounts) {
        const accountList = accounts.accountsList.reverse();
        this.accountList = accountList;
        this.currentAccount = accounts.currentAccount;
        accountList.forEach(async item => {
          const balance = await this.$store.dispatch('wallet/checkBalance', {accountname: item, needCommit: false});
          this.$set(this.priceMap, item, balance);
        });
        this.$refs['changeAccounts'].show();
      },
      show(show = true, showDeposit = false) {
        this.componentChecked = this.checked;
        this.showDeposit = showDeposit;
        this.$refs['modal'].show(show);
      },
      changeGameType(type) {
        this.componentChecked = type;
      },
      submitGameMode() {
        if (window.$chatwoot) {
          this.$nextTick(_ => {
            let accountName = this.accountName;
            let network = !this.isDemo ? 'testnet' : 'mainnet';
            if (accountName === 'No account') {
              accountName = '';
            }
            window.$chatwoot.setCustomAttributes({
              network: network,
              accountname: accountName
            });
            setTimeout(_ => {
              window.$chatwoot.setCustomAttributes({
                balance: this.balance.toFixed(4) + ' EOS',
                network: network,
                accountname: accountName
              });
            }, 5000)
          });
        }
        if (this.componentChecked === this.isDemo) return;
        this.ga('accept');
        this.isDemo = !this.componentChecked;
      },
      continueSubmitingGameMode() {
        this.$refs['modal'].show(false);
        if (this.showDeposit) {
          this.$nextTick(_ => {
            this.$root.$refs['headerTop'].openDeposit();
          });
        }
        this.showDeposit = false;
        this.$emit('checked', this.componentChecked);
        this.loading = false;
      },
      createAccount(accountName = localStorage.getItem('accountname')) {
        this.$store.dispatch('user/create', {
          username: accountName,
          public: {
            owner: this.pubKey,
            active: this.pubKey,
          },
          signature: 'sign',
          timestamp: new Date().getTime()
        }).then(res => {
          this.$store.dispatch('wallet/getAccount', {
            accountName
          });
          localStorage.setItem('accountname', accountName);
          this.$trigger('checkBonus');
        }).catch(e => {

        })
      }
    }
  }
</script>
